Subject: 28.0.50; Unwanted switch of foreground colour in *shell* buffer

From: Peter Dyballa <[email-masked]>
Date: Wed, 21 Oct 2020 20:10:28 +0200

Hello!

Recently *compilation* buffer was reserved by some other process so I decided to install some Python packages in *shell* buffer (with tcsh 6.21.00 (Astron) 2019-05-08 (x86_64-apple-darwin) options wide,nls,dl,bye,al,kan,sm,rh,color,filec) as root. The installation manager is https://www.macports.org/index.php. It produced this output in the end:

	--->  Installing py38-jsonschema @3.2.0_0
	--->  Activating py38-jsonschema @3.2.0_0
	--->  Cleaning py38-jsonschema
	--->  Updating database of binaries
	--->  Scanning binaries for linking errors
	--->  No broken files found.
	--->  No broken ports found.
	root 252 /\

Starting with the first '--->  No broken files found.' line the foreground colour was switched to red. The MacPorts folks claim that their 'port' binary does not emit any ANSI codes to change the colour.

I let this foreground colour – and by chance it happened that it was switched back during another installation:

	--->  Installing libomp @10.0.0_0
	--->  Activating libomp @10.0.0_0
	--->  Cleaning libomp
	--->  Fetching archive for clang-9.0
	--->  Attempting to fetch clang-9.0-9.0.1_1+analyzer+libstdcxx.darwin_19.x86_64.tbz2 from https://packages.macports.org/clang-9.0
	--->  Attempting to fetch clang-9.0-9.0.1_1+analyzer+libstdcxx.darwin_19.x86_64.tbz2.rmd160 from https://packages.macports.org/clang-9.0

The last line was in the usual colour again.

Right now I have to run GNU Emacs in Apple's Terminal application (Version 2.10 (433)) because X11 wants to create cache files of font files and is not allowed to do so for some font directories in read-only areas of the file system (clearing fontpath would be an option). The colour switches do not happen in *compilation* buffer. And I've seen similar behaviour four years ago – could be a version of 25.0.x.

	https://trac.macports.org/ticket/53404
	https://trac.macports.org/ticket/61357 (with a picture of colour changes happening in the Attachments section)

One idea of the cause for this is that the word "No" is triggering the colour change – similarly to configure output in *compilation* buffer, not being restricted for the single word.

In GNU Emacs 28.0.50 (build 1, x86_64-apple-darwin19.6.0)
 of 2020-09-15 built on catalina.internal.macports.net
Repository revision: 2a47ef86e95fad1dcc14a02e7471ba5d9cad4b9b
Repository branch: HEAD
System Description:  Mac OS X 10.15.7

Configured using:
 'configure --prefix=/opt/local --without-ns --without-x --without-dbus
 --without-gconf --without-libotf --without-m17n-flt --with-gmp
 --with-gnutls --with-json --with-xml2 --with-modules --infodir
 /opt/local/share/info/emacs 'CFLAGS=-pipe -Os
 -isysroot/Library/Developer/CommandLineTools/SDKs/MacOSX10.15.sdk -arch
 x86_64' 'CPPFLAGS=-I/opt/local/include
 -isysroot/Library/Developer/CommandLineTools/SDKs/MacOSX10.15.sdk'
 'LDFLAGS=-L/opt/local/lib -Wl,-headerpad_max_install_names -Wl,-no_pie
 -Wl,-syslibroot,/Library/Developer/CommandLineTools/SDKs/MacOSX10.15.sdk
 -arch x86_64''

Configured features:
NOTIFY KQUEUE ACL GNUTLS LIBXML2 ZLIB MODULES THREADS JSON PDUMPER

Important settings:
  value of $LC_CTYPE: de_DE.UTF-8
  value of $LANG: de_DE.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Shell

Minor modes in effect:
  shell-dirtrack-mode: t
  show-paren-mode: t
  midnight-mode: t
  display-time-mode: t
  desktop-save-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  size-indication-mode: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
/Library/Application Support/Emacs/preview-latex hides /opt/local/share/emacs/site-lisp/preview-latex
/Library/Application Support/Emacs/tex-site hides /opt/local/share/emacs/site-lisp/tex-site
/Library/Application Support/Emacs/auctex hides /opt/local/share/emacs/site-lisp/auctex
/Library/Application Support/Emacs/punycode hides /opt/local/share/emacs/site-lisp/punycode
/Library/Application Support/Emacs/idna hides /opt/local/share/emacs/site-lisp/idna
/Library/Application Support/Emacs/git hides /opt/local/share/emacs/site-lisp/git
/Library/Application Support/Emacs/cmake-mode hides /opt/local/share/emacs/site-lisp/cmake-mode
/Library/Application Support/Emacs/calendar28/cal-move hides /opt/local/share/emacs/28.0.50/lisp/calendar/cal-move
/Library/Application Support/Emacs/calendar28/lunar hides /opt/local/share/emacs/28.0.50/lisp/calendar/lunar
/Library/Application Support/Emacs/calendar28/solar hides /opt/local/share/emacs/28.0.50/lisp/calendar/solar
/Library/Application Support/Emacs/calendar28/icalendar hides /opt/local/share/emacs/28.0.50/lisp/calendar/icalendar
/Library/Application Support/Emacs/calendar28/calendar hides /opt/local/share/emacs/28.0.50/lisp/calendar/calendar
/Library/Application Support/Emacs/calendar28/cal-html hides /opt/local/share/emacs/28.0.50/lisp/calendar/cal-html
/Library/Application Support/Emacs/calendar28/cal-iso hides /opt/local/share/emacs/28.0.50/lisp/calendar/cal-iso
/Library/Application Support/Emacs/calendar28/cal-tex hides /opt/local/share/emacs/28.0.50/lisp/calendar/cal-tex
/Library/Application Support/Emacs/calendar28/parse-time hides /opt/local/share/emacs/28.0.50/lisp/calendar/parse-time
/Library/Application Support/Emacs/calendar28/holidays hides /opt/local/share/emacs/28.0.50/lisp/calendar/holidays
/Library/Application Support/Emacs/calendar28/cal-menu hides /opt/local/share/emacs/28.0.50/lisp/calendar/cal-menu
/Library/Application Support/Emacs/calendar28/cal-x hides /opt/local/share/emacs/28.0.50/lisp/calendar/cal-x
/Library/Application Support/Emacs/calendar28/diary-lib hides /opt/local/share/emacs/28.0.50/lisp/calendar/diary-lib

Features:
(shadow sort mail-extr emacsbug message rmc puny rfc822 mml mml-sec epa
epg epg-config gnus-util rmail rmail-loaddefs text-property-search
mm-decode mm-bodies mm-encode mail-parse rfc2231 mailabbrev gmm-utils
mailheader sendmail rfc2047 rfc2045 ietf-drums mm-util mail-prsvr
mail-utils smerge-mode diff diff-mode easy-mmode rect python tramp-sh
tramp tramp-loaddefs trampver tramp-integration files-x tramp-compat
parse-time iso8601 ls-lisp format-spec ffap thingatpt url-parse
auth-source eieio eieio-core eieio-loaddefs password-cache json map
url-vars cc-mode cc-fonts cc-guess cc-menus cc-cmds cc-styles cc-align
cc-engine cc-vars cc-defs view time-stamp pcmpl-unix pcmpl-gnu compile
tool-bar cal-julian holidays hol-loaddefs mule-util cal-move derived
cal-menu calendar cal-loaddefs cl-seq cl-extra seq help-fns radix-tree
cl-print debug backtrace help-mode find-func misearch multi-isearch
dired-aux term/xterm xterm byte-opt bytecomp byte-compile cconv
autorevert filenotify dired dired-loaddefs time-date subr-x easymenu
shell pcomplete comint regexp-opt ansi-color ring fringe jka-compr paren
midnight time image cus-start cus-load iso-transl edmacro kmacro cl-macs
cl gv session desktop frameset cl-loaddefs cl-lib advice tooltip eldoc
electric uniquify ediff-hook vc-hooks lisp-float-type tabulated-list
replace newcomment text-mode elisp-mode lisp-mode prog-mode register
page tab-bar menu-bar rfn-eshadow isearch timer select mouse jit-lock
font-lock syntax facemenu font-core term/tty-colors frame minibuffer
cl-generic cham georgian utf-8-lang misc-lang vietnamese tibetan thai
tai-viet lao korean japanese eucjp-ms cp51932 hebrew greek romanian
slovak czech european ethiopic indian cyrillic chinese composite
charscript charprop case-table epa-hook jka-cmpr-hook help simple abbrev
obarray cl-preloaded nadvice loaddefs button faces cus-face macroexp
files text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote threads kqueue
multi-tty make-network-process emacs)

Memory information:
((conses 16 302871 10754)
 (symbols 48 15543 1)
 (strings 32 47165 1784)
 (string-bytes 1 1964514)
 (vectors 16 20200)
 (vector-slots 8 225743 11443)
 (floats 8 89 792)
 (intervals 56 16600 1270)
 (buffers 992 26))

--
Greetings

  Pete

When you meet a master swordsman,
show him your sword.
When you meet a man who is not a poet,
do not show him your poem.
			– Rinzai, ninth century Zen master